window.addEventListener('load', dockconfig, false);

function dockconfig () {
	var dock = document.getElementById('dock');
	var main = document.getElementById('root');
	var items = dock.getElementsByTagName('a');
	var draggedItem = null;
	
	function updatecookie() {
		var as = dock.getElementsByTagName('a');
		var s = '';
		for (var i=1; i < as.length; i++) {
			s += as[i].href.lastPathComponent() + ',';
		};
		s = s.substr(0, s.length-1);
		var c = new Cookie();
		c.setValue_forKey_(s, 'dock');
		c.save();
	}

	// Set up removal of Dock items
	// Start at 1 to avoid first dock item (isn't removable)
	for (var i=1; i < items.length; i++) {
		items[i].ondragstart = function (e) { 
			draggedItem = this; 
			main.ondragenter = function(e) { e.preventDefault(); }
			main.ondragover = function (e) { e.preventDefault() }
			main.ondrop = function(e) { dock.removeChild(draggedItem); updatecookie(); }
		}
		items[i].ondragend = function (e) { 
			draggedItem = null; 
			main.ondragenter = null;
			main.ondragover = null;
			main.ondrop = null;
		}
	}
	
	
	// Set up addition of Dock items
	var rows = main.getElementsByTagName('tr');
	for (var i=0; i < rows.length; i++) {
		rows[i].ondragstart = function(e) {
			var draggedRow = this;
			dock.ondragenter = function(e) { e.preventDefault(); }
			dock.ondragover = function(e) { e.preventDefault(); }
			dock.ondrop = function(e) {
				var a = draggedRow.getElementsByTagName('a')[0];
				var img = a.firstChild;
				var txt = a.childNodes[1].data;
				var href = a.href.lastPathComponent();
				
				var dockItem = document.createElement("a");
				var itemImg = document.createElement("img");
				var span = document.createElement("span");

				dockItem.href = href;
				itemImg.src = img.src;
				span.appendChild(document.createTextNode(txt));

				dock.appendChild(dockItem);
				dockItem.appendChild(itemImg);
				dockItem.appendChild(span);
				
				updatecookie();
			}
		}
		rows[i].ondragend = function(e) {
			dock.ondragenter = null;
			dock.ondragover = null;
			dock.ondrop = null;
		}
	}
}
